<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Lucky Dice Casino v1.0</title>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .picture-cover {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }

    </style>
</head>

<body>
    <div class="container-fluid picture-cover"> </div>
    <div class="container">
        <div class="row">
           <div class="col-5">
                <div class="row">
                   <div class="col-12 text-center">
                       <h2> Nhập thông tin của bạn</h2>
                   </div>
                </div>
                <hr>
                <div class="row">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-username" class="form-control" value="namvh">
                    </div>
                </div>
                <div class="row">
                    <div class="col-4">
                        <label>First name</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-firstname" class="form-control" value="vu">
                    </div>
                </div>
                <div class="row">
                    <div class="col-4">
                        <label>Last name</label>
                    </div>
                    <div class="col-8">
                        <input id="inp-lastname" class="form-control" value="nam">
                    </div>
                </div>
            </div>
           <div class="col-4 text-center">
               <div class="row">
                   <div class="col-12">
                    <button id="btn-dice" class="btn w-75"><i class="fas fa-dice-six"></i>&nbsp; Ném &nbsp;<i class="fas fa-dice-six"></i></button>
                   </div>
               </div>
               <br>
               <div class="row">
                    <div class="col-12">
                        <img id="img-dice" src="LuckyDiceImages/dice.png" class="img-thumbnail">
                    </div>
                </div>
                <br>
                <div class="row">
                    <div class="col-12 ">
                        <p id="p-notification-dice" style="color: rgb(171, 41, 41);">Chúc Mừng</p>
                    </div>
                </div>
           </div>
           <div class="col-3">
                <div class="row form-group">
                    <div class="col-12 text-center">
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                       <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/no-present.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row text-center form-group">
           <div class="col-12">
                <button id="btn-dice-history" class="btn btn-primary w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-primary w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-primary w-25">Present History</button>
           </div>
        </div>
        <div class="row">
           <div class="col-12">
               <table id="history-table" class="table table-striped table-hover border">
                   <thead>
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                   </thead>
                   <tbody id="tbody-history">

                   </tbody>
               </table>
           </div>
        </div>
    </div>

    
</body>
<script>
    "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    
    const gEND_OF_ROW_COL = -1;
    const gUserObj = {
        username: "",
        firstname: "",
        lastname: ""
    }

/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function() {
        //sự kiện bấm nút ném dice
        $("#btn-dice").click(function() {
            $("#btn-dice").toggleClass("btn-success");
            onBtnNewDice();
        });
        
        //sự kiện bấm dice history
        $("#btn-dice-history").on("click", function() {
            onBtnDiceHistory();
        })

        //sự kiện bấm voucher history
        $("#btn-voucher-history").on("click", function() {
            onBtnVoucherHistory();
        })

        //sự kiện bấm prize history
        $("#btn-present-history").on("click", function() {
            onBtnPrizeHistory();
        })
    })

/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý ném xúc xắc
    function onBtnNewDice() {
        "use strict";
        console.log("%cThrow New Dice!", "color:red");
        //buoc 1: thu thap du lieu
        getData(gUserObj);
        //buoc 2: kiem tra du lieu
        var vCheckData = validateData(gUserObj);
        if ( vCheckData == true ) {
            //buoc 3: send request API & show result
            callAPIGetNewDice(gUserObj);
        }
    }

    // hàm xử lý xem lịch sử ném xúc xắc
    function onBtnDiceHistory() {
        "use strict";
        console.log("%cDice History Clicked!", "color:blue");
        changeColorBtn("Dice");
        //bước 1: thu thập dữ liệu
        getData(gUserObj);
        //bước 2: kiểm tra dữ liệu
        var vCheckData = validateData(gUserObj);
        var vDiceHistoryTable = document.getElementById("history-table");
        vDiceHistoryTable.rows[0].cells[0].innerHTML = "Lượt";
        vDiceHistoryTable.rows[0].cells[1].innerHTML = "Dice";
        if ( vCheckData == true ) {
            //bước 3: call API lấy Dice History
            callAPIGetDiceHistory(gUserObj);
        }
    }

    // hàm xem lịch sử voucher
    function onBtnVoucherHistory() {
        "use strict";
        console.log("%cVoucher History Clicked!", "color:red");
        changeColorBtn("Voucher");
        //bước 1: thu thập dữ liệu
        getData(gUserObj);
        //bước 2: kiểm tra dữ liệu
        var vCheckData = validateData(gUserObj);
        var vDiceHistoryTable = document.getElementById("history-table");
        vDiceHistoryTable.rows[0].cells[0].innerHTML = "Voucher ID";
        vDiceHistoryTable.rows[0].cells[1].innerHTML = "Discount";
        if ( vCheckData == true ) {
            //bước 3: call API lấy Voucher History
            callAPIGetVoucherHistory(gUserObj);
        } 
    }

    //hàm xử lý sự kiện hiển thị prize history
    function onBtnPrizeHistory() {
        "use strict";
        console.log("%cPresent History Clicked!", "color:purple");
        changeColorBtn("Present")
        //bước 1: thu thập dữ liệu
        getData(gUserObj);
        //bước 2: kiểm tra dữ liệu
        var vCheckData = validateData(gUserObj);
        var vDiceHistoryTable = document.getElementById("history-table");
        vDiceHistoryTable.rows[0].cells[0].innerHTML = "Game";
        vDiceHistoryTable.rows[0].cells[1].innerHTML = "Presents";
        if ( vCheckData == true ) {
            //bước 3: call API lấy Prize History
        callAPIGetPrizeHistory(gUserObj);
        }
    }    
/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dữ liệu
    function getData(paramUserObj) {
        "use strict";
        paramUserObj.username = $("#inp-username").val();
        paramUserObj.firstname = $("#inp-firstname").val();
        paramUserObj.lastname = $("#inp-lastname").val();
    }

    //hàm kiểm tra dữ liệu
    function validateData(paramUserObj) {
        "use strict";
        if ( paramUserObj.username === "" ) {
            alert("username chua nhap!");
            return false;
        }
        
        if ( paramUserObj.firstname === "" ) {
            alert("first name chua nhap!");
            return false;
        }

        if ( paramUserObj.lastname === "" ) {
            alert("last name chua nhap!");
            return false;
        }
        return true;
    }

    //hàm call API tung xúc xắc mới & hiển thị kết quả 
    function callAPIGetNewDice(paramUserObj) {
        "use strict";
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-lucky-dice/dice",
            type: 'POST',
            contentType: "application/json;charset=UTF-8" ,
            data: JSON.stringify(paramUserObj),
            success: function(responseObj) {
                displayResults(responseObj);
            },
            error: function(errorContent) {
                alert(errorContent.responseText);
            }
        })
    }

    //hàm hiển thị kết quả sau khi tung xúc xắc
    function displayResults(paramResponseObj) {
            // get result dice
            var vDiceReady = paramResponseObj.dice;
    
            console.log("dice result:= " + vDiceReady);
               
            //hien thi Xuc Xac
            changeDice(vDiceReady);

            //hien thi loi nhan
            changeNotification(vDiceReady);
                
            //hiển thị voucher
            showVoucher(paramResponseObj);
                
            //hiển thị prize
            showPresent(paramResponseObj);
    }

    //hàm call API lấy voucher history
    function callAPIGetVoucherHistory(paramUserObj) {
        "use strict";
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-lucky-dice/voucher-history?username=" + paramUserObj.username,
            type: 'GET',
            dataType: 'json',
            success: function(responseObj) {
                console.log(responseObj);
                displayVoucherHistory(responseObj);
            }

        })
    }

    //hàm call API lấy prize history
    function callAPIGetPrizeHistory(paramUserObj) {
        "use strict";
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-lucky-dice/prize-history?username=" + paramUserObj.username,
            type: 'GET',
            dataType: 'json',
            success: function(responseObj) {
                console.log(responseObj);
                displayPrizeHistory(responseObj);
            }

        })
    }

    // hàm call API lấy Dice History
    function callAPIGetDiceHistory(paramUserObj) {
        "use strict";
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-lucky-dice/dice-history?username=" + paramUserObj.username,
            type: 'GET',
            dataType: 'json',
            success: function(responseObj) {
                console.log(responseObj);
                displayDiceHistory(responseObj);
            }

        })
    }

    //hàm hiển thị kết quả
    function changeDice(paramDiceReady) {
        "use strict";
        var vNewDice = document.getElementById("img-dice");
        switch (paramDiceReady) {
            case 1:
                vNewDice.src = "LuckyDiceImages/1.png";
                break;
            case 2:
                vNewDice.src = "LuckyDiceImages/2.png";
                break;
            case 3:
                vNewDice.src = "LuckyDiceImages/3.png";
                break;
            case 4:
                vNewDice.src = "LuckyDiceImages/4.png";
                break;
            case 5: 
                vNewDice.src = "LuckyDiceImages/5.png";
                break;
            default:
                vNewDice.src = "LuckyDiceImages/6.png";
        }
    }

//hàm hiển thị lời nhắn
function changeNotification(paramDiceReady) {
    "use strict";
    if ( paramDiceReady < 4 ) {
        $("#p-notification-dice").html("Chúc bạn may mắn lần sau!");
    }
    else {
        $("#p-notification-dice").html("Chúc mừng bạn! Hãy chơi tiếp để thắng lớn!");
    }
}

//hàm hiển thị voucher 
function showVoucher(paramResponse) {
    "use strict";
    if ( paramResponse.voucher != null ) {
        $("#p-voucher-id").html("ID : " + paramResponse.voucher.maVoucher)
        $("#p-voucher-percent").html("Phần trăm giảm giá : " + paramResponse.voucher.phanTramGiamGia + " %");
    }
    else {
        $("#p-voucher-id").html("");
        $("#p-voucher-percent").html("");
    }
}

//hàm hiển thị present
function showPresent(paramResponse) {
    "use strict";
    switch (paramResponse.prize) {
        case "Mũ":
            $("#img-present").attr("src","LuckyDiceImages/hat.jpg");
            break;
        case "Áo":
            $("#img-present").attr("src","LuckyDiceImages/t-shirt.jpg");
            break;
        case "Xe máy":
            $("#img-present").attr("src","LuckyDiceImages/xe-may.jpg");
            break;
        case "Ô tô":
            $("#img-present").attr("src","LuckyDiceImages/car.jpg");
            break;
        default:
            $("#img-present").attr("src","LuckyDiceImages/no-present.jpg")
    }
}

//hàm display dice history
function displayDiceHistory(paramDiceHistory) {
    var vTableBody = document.getElementById("tbody-history");
    vTableBody.innerHTML = "";
    for(var bI = 0; bI < paramDiceHistory.dices.length; bI ++){
        var bRow = vTableBody.insertRow(gEND_OF_ROW_COL);
        var bCellSTT = bRow.insertCell(0);
        var bCellDice = bRow.insertCell(1);

        bCellSTT.innerHTML = bI + 1;
        bCellDice.innerHTML = paramDiceHistory.dices[bI];
    }
}

    // hàm display voucher history
    function displayVoucherHistory(paramVoucherHistory) {
        var vTableBody = document.getElementById("tbody-history");
        vTableBody.innerHTML = "";
        for(var bI = 0; bI < paramVoucherHistory.vouchers.length; bI ++){
            var bRow = vTableBody.insertRow(gEND_OF_ROW_COL);
            var bCellVoucher = bRow.insertCell(0);
            var bCellPercent = bRow.insertCell(1);

            bCellVoucher.innerHTML = paramVoucherHistory.vouchers[bI].maVoucher;
            bCellPercent.innerHTML = paramVoucherHistory.vouchers[bI].phanTramGiamGia + "%";
        }
    }

    //hàm display prize history
    function displayPrizeHistory(paramPrizeHistory) {
        "use strict";
        var vTableBody = document.getElementById("tbody-history");
        vTableBody.innerHTML = "";
        for(var bI = 0; bI < paramPrizeHistory.prizes.length; bI ++){
            var bRow = vTableBody.insertRow(gEND_OF_ROW_COL);
            var bCellSTT = bRow.insertCell(0);
            var bCellPresent = bRow.insertCell(1);

            bCellSTT.innerHTML = bI + 1;
            bCellPresent.innerHTML = paramPrizeHistory.prizes[bI];
        }
    }


//hàm đổi màu nút 
function changeColorBtn(paramBtn) {
    "use strict";
    switch(paramBtn) {
        case "Dice":
            $("#btn-dice-history").removeClass("btn-primary");
            $("#btn-dice-history").addClass("btn-warning");
            $("#btn-voucher-history").removeClass("btn-warning");
            $("#btn-voucher-history").addClass("btn-primary");
            $("#btn-present-history").removeClass("btn-warning");
            $("#btn-present-history").addClass("btn-primary");
            break;

        case "Voucher":
            $("#btn-dice-history").addClass("btn-primary");
            $("#btn-dice-history").removeClass("btn-warning");
            $("#btn-voucher-history").addClass("btn-warning");
            $("#btn-voucher-history").removeClass("btn-primary");
            $("#btn-present-history").removeClass("btn-warning");
            $("#btn-present-history").addClass("btn-primary");
            break;

        case "Present":
            $("#btn-dice-history").addClass("btn-primary");
            $("#btn-dice-history").removeClass("btn-warning");
            $("#btn-voucher-history").removeClass("btn-warning");
            $("#btn-voucher-history").addClass("btn-primary");
            $("#btn-present-history").addClass("btn-warning");
            $("#btn-present-history").removeClass("btn-primary");
            break;

    }

}
</script>
</html>